当前位置:   article > 正文

社招面经总结——算法题篇

算法题和面经的关系

面试结果

总结下最近的面试:

  • 头条后端:3面技术面挂
  • 蚂蚁支付宝营销-机器学习平台开发: 技术面通过,年后被通知只有P7的hc
  • 蚂蚁中台-机器学习平台开发: 技术面通过, 被蚂蚁HR挂掉(脉脉上好多人遇到这种情况,一个是今年大环境不好,另一个,面试尽量不要赶上阿里财年年底,这算是一点tips吧)
  • 快手后端: 拿到offer
  • 百度后端: 拿到offer

最终拒了百度,去快手了, 一心想去阿里, 个人有点阿里情节吧,缘分差点。 总结下最近的面试情况, 由于面了20多面, 就按照题型分类给大家一个总结。推荐大家每年都要抽出时间去面一下,不一定跳槽,但是需要知道自己的不足,一定要你的工龄匹配上你的能力。比如就我个人来说,通过面试我知道数据库的知识不是很懂,再加上由于所在组对数据库接触较少,这就是短板,作为一个后端工程师对数据库说不太了解是很可耻的,在选择offer的时候就可以适当有偏向性。下面分专题把最近的面试总结和大家总结一下。过分简单的就不说了,比如打印一个图形啥的, 还有的我不太记得清了,比如快手一面好像是一道动态规划的题目。当然,可能有的解决方法不是很好,大家可以在手撕代码群里讨论。最后一篇我再谈一下一些面试的技巧啥的。麻烦大家点赞转发支持下~

股票买卖(头条)

Leetcode 上有三题股票买卖,面试的时候只考了两题,分别是easy 和medium的难度

Leetcode 121. 买卖股票的最佳时机

给定一个数组,它的第 i 个元素是一支给定股票第 i 天的价格。

如果你最多只允许完成一笔交易(即买入和卖出一支股票),设计一个算法来计算你所能获取的最大利润。

注意你不能在买入股票前卖出股票。

示例 1:

  1. 输入: [7,1,5,3,6,4]
  2. 输出: 5
  3. 复制代码

解释: 在第 2 天(股票价格 = 1)的时候买入,在第 5 天(股票价格 = 6)的时候卖出,最大利润 = 6-1 = 5 。 注意利润不能是 7-1 = 6, 因为卖出价格需要大于买入价格。 示例 2:

  1. 输入: [7,6,4,3,1]
  2. 输出: 0
  3. 复制代码

解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。

题解

纪录两个状态, 一个是最大利润, 另一个是遍历过的子序列的最小值。知道之前的最小值我们就可以算出当前天可能的最大利润是多少

  1. class Solution {
  2. public int maxProfit(int[] prices) {
  3. // 7,1,5,3,6,4
  4. int maxProfit = 0;
  5. int minNum = Integer.MAX_VALUE;
  6. for (int i = 0; i < prices.length; i++) {
  7. if (Integer.MAX_VALUE != minNum && prices[i] - minNum > maxProfit) {
  8. maxProfit = prices[i] - minNum;
  9. }
  10. if (prices[i] < minNum) {
  11. minNum = prices[i];
  12. }
  13. }
  14. return maxProfit;
  15. }
  16. }
  17. 复制代码

Leetcode 122. 买卖股票的最佳时机 II

这次改成股票可以买卖多次, 但是你必须要在出售股票之前把持有的股票卖掉。 示例 1:

  1. 输入: [7,1,5,3,6,4]
  2. 输出: 7
  3. 解释: 在第 2 天(股票价格 = 1)的时候买入,在第 3 天(股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
  4. 随后,在第 4 天(股票价格 = 3)的时候买入,在第 5 天(股票价格 = 6)的时候卖出, 这笔交易所能获得利润 = 6-3 = 3 。
  5. 复制代码

示例 2:

  1. 输入: [1,2,3,4,5]
  2. 输出: 4
  3. 解释: 在第 1 天(股票价格 = 1)的时候买入,在第 5 天 (股票价格 = 5)的时候卖出, 这笔交易所能获得利润 = 5-1 = 4 。
  4. 注意你不能在第 1 天和第 2 天接连购买股票,之后再将它们卖出。
  5. 因为这样属于同时参与了多笔交易,你必须在再次购买前出售掉之前的股票。
  6. 复制代码

示例 3:

  1. 输入: [7,6,4,3,1]
  2. 输出: 0
  3. 解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
  4. 复制代码

题解

由于可以无限次买入和卖出。我们都知道炒股想挣钱当然是低价买入高价抛出,那么这里我们只需要从第二天开始,如果当前价格比之前价格高,则把差值加入利润中,因为我们可以昨天买入,今日卖出,若明日价更高的话,还可以今日买入,明日再抛出。以此类推,遍历完整个数组后即可求得最大利润。

  1. class Solution {
  2. public int maxProfit(int[] prices) {
  3. // 7,1,5,3,6,4
  4. int maxProfit = 0;
  5. for (int i = 0; i < prices.length; i++) {
  6. if (i != 0 && prices[i] - prices[i-1] > 0) {
  7. maxProfit += prices[i] - prices[i-1];
  8. }
  9. }
  10. return maxProfit;
  11. }
  12. }
  13. 复制代码

LRU cache (头条、蚂蚁)

这道题目是头条的高频题目,甚至我怀疑,头条这个面试题是题库里面的必考题。看脉脉也是好多人遇到。第一次我写的时候没写好,可能由于这个挂了。

转自知乎:zhuanlan.zhihu.com/p/34133067

题目

运用你所掌握的数据结构,设计和实现一个 LRU (最近最少使用) 缓存机制。它应该支持以下操作: 获取数据 get 和 写入数据 put 。

获取数据 get(key) - 如果密钥 (key) 存在于缓存中,则获取密钥的值(总是正数),否则返回 -1。 写入数据 put(key, value) - 如果密钥不存在,则写入其数据值。当缓存容量达到上限时,它应该在写入新数据之前删除最近最少使用的数据值,从而为新的数据值留出空间。

进阶:

你是否可以在 O(1) 时间复杂度内完成这两种操作?

  1. LRUCache cache = new LRUCache( 2 /* 缓存容量 */ );
  2. cache.put(1, 1);
  3. cache.put(2, 2);
  4. cache.get(1); // 返回 1
  5. cache.put(3, 3); // 该操作会使得密钥 2 作废
  6. cache.get(2); // 返回 -1 (未找到)
  7. cache.put(4, 4); // 该操作会使得密钥 1 作废
  8. cache.get(1); // 返回 -1 (未找到)
  9. cache.get(3); // 返回 3
  10. cache.get(4); // 返回 4
  11. 复制代码

题解

这道题在今日头条、快手或者硅谷的公司中是比较常见的,代码要写的还蛮多的,难度也是hard级别。

最重要的是LRU 这个策略怎么去实现, 很容易想到用一个链表去实现最近使用的放在链表的最前面。 比如get一个元素,相当于被使用过了,这个时候它需要放到最前面,再返回值, set同理。 那如何把一个链表的中间元素,快速的放到链表的开头呢? 很自然的我们想到了双端链表。

基于 HashMap 和 双向链表实现 LRU 的

整体的设计思路是,可以使用 HashMap 存储 key,这样可以做到 save 和 get key的时间都是 O(1),而 HashMap 的 Value 指向双向链表实现的 LRU 的 Node 节点,如图所示。

LRU 存储是基于双向链表实现的,下面的图演示了它的原理。其中 head 代表双向链表的表头,tail 代表尾部。首先预先设置 LRU 的容量,如果存储满了,可以通过 O(1) 的时间淘汰掉双向链表的尾部,每次新增和访问数据,都可以通过 O(1)的效率把新的节点增加到对头,或者把已经存在的节点移动到队头。

下面展示了,预设大小是 3 的,LRU存储的在存储和访问过程中的变化。为了简化图复杂度,图中没有展示 HashMap部分的变化,仅仅演示了上图 LRU 双向链表的变化。我们对这个LRU缓存的操作序列如下:

  1. save("key1", 7)
  2. save("key2", 0)
  3. save("key3", 1)
  4. save("key4", 2)
  5. get("key2")
  6. save("key5", 3)
  7. get("key2")
  8. save("key6", 4)
  9. 复制代码

相应的 LRU 双向链表部分变化如下:

总结一下核心操作的步骤:

save(key, value),首先在 HashMap 找到 Key 对应的节点,如果节点存在,更新节点的值,并把这个节点移动队头。如果不存在,需要构造新的节点,并且尝试把节点塞到队头,如果LRU空间不足,则通过 tail 淘汰掉队尾的节点,同时在 HashMap 中移除 Key。

get(key),通过 HashMap 找到 LRU 链表节点,因为根据LRU 原理,这个节点是最新访问的,所以要把节点插入到队头,然后返回缓存的值。

  1. private static class DLinkedNode {
  2. int key;
  3. int value;
  4. DLinkedNode pre;
  5. DLinkedNode post;
  6. }
  7. /**
  8. * 总是在头节点中插入新节点.
  9. */
  10. private void addNode(DLinkedNode node) {
  11. node.pre = head;
  12. node.post = head.post;
  13. head.post.pre = node;
  14. head.post = node;
  15. }
  16. /**
  17. * 摘除一个节点.
  18. */
  19. private void removeNode(DLinkedNode node) {
  20. DLinkedNode pre = node.pre;
  21. DLinkedNode post = node.post;
  22. pre.post = post;
  23. post.pre = pre;
  24. }
  25. /**
  26. * 摘除一个节点,并且将它移动到开头
  27. */
  28. private void moveToHead(DLinkedNode node) {
  29. this.removeNode(node);
  30. this.addNode(node);
  31. }
  32. /**
  33. * 弹出最尾巴节点
  34. */
  35. private DLinkedNode popTail() {
  36. DLinkedNode res = tail.pre;
  37. this.removeNode(res);
  38. return res;
  39. }
  40. private HashMap<Integer, DLinkedNode>
  41. cache = new HashMap<Integer, DLinkedNode>();
  42. private int count;
  43. private int capacity;
  44. private DLinkedNode head, tail;
  45. public LRUCache(int capacity) {
  46. this.count = 0;
  47. this.capacity = capacity;
  48. head = new DLinkedNode();
  49. head.pre = null;
  50. tail = new DLinkedNode();
  51. tail.post = null;
  52. head.post = tail;
  53. tail.pre = head;
  54. }
  55. public int get(int key) {
  56. DLinkedNode node = cache.get(key);
  57. if (node == null) {
  58. return -1; // cache里面没有
  59. }
  60. // cache 命中,挪到开头
  61. this.moveToHead(node);
  62. return node.value;
  63. }
  64. public void put(int key, int value) {
  65. DLinkedNode node = cache.get(key);
  66. if (node == null) {
  67. DLinkedNode newNode = new DLinkedNode();
  68. newNode.key = key;
  69. newNode.value = value;
  70. this.cache.put(key, newNode);
  71. this.addNode(newNode);
  72. ++count;
  73. if (count > capacity) {
  74. // 最后一个节点弹出
  75. DLinkedNode tail = this.popTail();
  76. this.cache.remove(tail.key);
  77. count--;
  78. }
  79. } else {
  80. // cache命中,更新cache.
  81. node.value = value;
  82. this.moveToHead(node);
  83. }
  84. }
  85. 复制代码

二叉树层次遍历(头条)

这个题目之前也讲过,Leetcode 102题。

题目

给定一个二叉树,返回其按层次遍历的节点值。 (即逐层地,从左到右访问所有节点)。

例如: 给定二叉树: [3,9,20,null,null,15,7],

  1. 3
  2. / \
  3. 9 20
  4. / \
  5. 15 7
  6. 复制代码

返回其层次遍历结果:

  1. [
  2. [3],
  3. [9,20],
  4. [15,7]
  5. ]
  6. 复制代码

题解

我们数据结构的书上教的层序遍历,就是利用一个队列,不断的把左子树和右子树入队。但是这个题目还要要求按照层输出。所以关键的问题是: 如何确定是在同一层的。 我们很自然的想到: 如果在入队之前,把上一层所有的节点出队,那么出队的这些节点就是上一层的列表。 由于队列是先进先出的数据结构,所以这个列表是从左到右的。

  1. /**
  2. * Definition for a binary tree node.
  3. * public class TreeNode {
  4. * int val;
  5. * TreeNode left;
  6. * TreeNode right;
  7. * TreeNode(int x) { val = x; }
  8. * }
  9. */
  10. class Solution {
  11. public List<List<Integer>> levelOrder(TreeNode root) {
  12. List<List<Integer>> res = new LinkedList<>();
  13. if (root == null) {
  14. return res;
  15. }
  16. LinkedList<TreeNode> queue = new LinkedList<>();
  17. queue.add(root);
  18. while (!queue.isEmpty()) {
  19. int size = queue.size();
  20. List<Integer> currentRes = new LinkedList<>();
  21. // 当前队列的大小就是上一层的节点个数, 依次出队
  22. while (size > 0) {
  23. TreeNode current = queue.poll();
  24. if (current == null) {
  25. continue;
  26. }
  27. currentRes.add(current.val);
  28. // 左子树和右子树入队.
  29. if (current.left != null) {
  30. queue.add(current.left);
  31. }
  32. if (current.right != null) {
  33. queue.add(current.right);
  34. }
  35. size--;
  36. }
  37. res.add(currentRes);
  38. }
  39. return res;
  40. }
  41. }
  42. 复制代码

这道题可不可以用非递归来解呢?

递归的子问题:遍历当前节点, 对于当前层, 遍历左子树的下一层层,遍历右子树的下一层

递归结束条件: 当前层,当前子树节点是null

  1. /**
  2. * Definition for a binary tree node.
  3. * public class TreeNode {
  4. * int val;
  5. * TreeNode left;
  6. * TreeNode right;
  7. * TreeNode(int x) { val = x; }
  8. * }
  9. */
  10. class Solution {
  11. public List<List<Integer>> levelOrder(TreeNode root) {
  12. List<List<Integer>> res = new LinkedList<>();
  13. if (root == null) {
  14. return res;
  15. }
  16. levelOrderHelper(res, root, 0);
  17. return res;
  18. }
  19. /**
  20. * @param depth 二叉树的深度
  21. */
  22. private void levelOrderHelper(List<List<Integer>> res, TreeNode root, int depth) {
  23. if (root == null) {
  24. return;
  25. }
  26. if (res.size() <= depth) {
  27. // 当前层的第一个节点,需要new 一个list来存当前层.
  28. res.add(new LinkedList<>());
  29. }
  30. // depth 层,把当前节点加入
  31. res.get(depth).add(root.val);
  32. // 递归的遍历下一层.
  33. levelOrderHelper(res, root.left, depth + 1);
  34. levelOrderHelper(res, root.right, depth + 1);
  35. }
  36. }
  37. 复制代码

二叉树转链表(快手)

这是Leetcode 104题。 给定一个二叉树,原地将它展开为链表。

例如,给定二叉树

  1. 1
  2. / \
  3. 2 5
  4. / \ \
  5. 3 4 6
  6. 复制代码

将其展开为:

  1. 1
  2. \
  3. 2
  4. \
  5. 3
  6. \
  7. 4
  8. \
  9. 5
  10. \
  11. 6
  12. 复制代码

这道题目的关键是转换的时候递归的时候记住是先转换右子树,再转换左子树。 所以需要记录一下右子树转换完之后链表的头结点在哪里。注意没有新定义一个next指针,而是直接将right 当做next指针,那么Left指针我们赋值成null就可以了。

  1. class Solution {
  2. private TreeNode prev = null;
  3. public void flatten(TreeNode root) {
  4. if (root == null) return;
  5. flatten(root.right); // 先转换右子树
  6. flatten(root.left);
  7. root.right = prev; // 右子树指向链表的头
  8. root.left = null; // 把左子树置空
  9. prev = root; // 当前结点为链表头
  10. }
  11. }
  12. 复制代码

用递归解法,用一个stack 记录节点,右子树先入栈,左子树后入栈。

  1. class Solution {
  2. public void flatten(TreeNode root) {
  3. if (root == null) return;
  4. Stack<TreeNode> stack = new Stack<TreeNode>();
  5. stack.push(root);
  6. while (!stack.isEmpty()) {
  7. TreeNode current = stack.pop();
  8. if (current.right != null) stack.push(current.right);
  9. if (current.left != null) stack.push(current.left);
  10. if (!stack.isEmpty()) current.right = stack.peek();
  11. current.left = null;
  12. }
  13. }
  14. }
  15. 复制代码

二叉树寻找最近公共父节点(快手)

Leetcode 236 二叉树的最近公共父亲节点

题解

从根节点开始遍历,如果node1和node2中的任一个和root匹配,那么root就是最低公共祖先。 如果都不匹配,则分别递归左、右子树,如果有一个 节点出现在左子树,并且另一个节点出现在右子树,则root就是最低公共祖先. 如果两个节点都出现在左子树,则说明最低公共祖先在左子树中,否则在右子树。

  1. public class Solution {
  2. public TreeNode lowestCommonAncestor(TreeNode root, TreeNode p, TreeNode q) {
  3. //发现目标节点则通过返回值标记该子树发现了某个目标结点
  4. if(root == null || root == p || root == q) return root;
  5. //查看左子树中是否有目标结点,没有为null
  6. TreeNode left = lowestCommonAncestor(root.left, p, q);
  7. //查看右子树是否有目标节点,没有为null
  8. TreeNode right = lowestCommonAncestor(root.right, p, q);
  9. //都不为空,说明做右子树都有目标结点,则公共祖先就是本身
  10. if(left!=null&&right!=null) return root;
  11. //如果发现了目标节点,则继续向上标记为该目标节点
  12. return left == null ? right : left;
  13. }
  14. }
  15. 复制代码

数据流求中位数(蚂蚁)

面了蚂蚁中台的团队,二面面试官根据汇报层级推测应该是P9级别及以上,在美国面我,面试风格偏硅谷那边。题目是hard难度的,leetcode 295题。 这道题目是Leetcode的hard难度的原题。给定一个数据流,求数据流的中位数,求中位数或者topK的问题我们通常都会想用堆来解决。 但是面试官又进一步加大了难度,他要求内存使用很小,没有磁盘,但是压榨空间的同时可以忍受一定时间的损耗。且面试官不仅要求说出思路,要写出完整可经过大数据检测的production code。

先不考虑内存

不考虑内存的方式就是Leetcode 论坛上的题解。 基本思想是建立两个堆。左边是大根堆,右边是小根堆。 如果是奇数的时候,大根堆的堆顶是中位数。

例如:[1,2,3,4,5] 大根堆建立如下:

  1. 3
  2. / \
  3. 1 2
  4. 复制代码

小根堆建立如下:

  1. 4
  2. /
  3. 5
  4. 复制代码

偶数的时候则是最大堆和最小堆顶的平均数。

例如: [1, 2, 3, 4]

大根堆建立如下:

  1. 2
  2. /
  3. 1
  4. 复制代码

小根堆建立如下:

  1. 3
  2. /
  3. 4
  4. 复制代码

然后再维护一个奇数偶数的状态即可求中位数。

  1. public class MedianStream {
  2. private PriorityQueue<Integer> leftHeap = new PriorityQueue<>(5, Collections.reverseOrder());
  3. private PriorityQueue<Integer> rightHeap = new PriorityQueue<>(5);
  4. private boolean even = true;
  5. public double getMedian() {
  6. if (even) {
  7. return (leftHeap.peek() + rightHeap.peek()) / 2.0;
  8. } else {
  9. return leftHeap.peek();
  10. }
  11. }
  12. public void addNum(int num) {
  13. if (even) {
  14. rightHeap.offer(num);
  15. int rightMin = rightHeap.poll();
  16. leftHeap.offer(rightMin);
  17. } else {
  18. leftHeap.offer(num);
  19. int leftMax = leftHeap.poll();
  20. rightHeap.offer(leftMax);
  21. }
  22. System.out.println(leftHeap);
  23. System.out.println(rightHeap);
  24. // 奇偶变换.
  25. even = !even;
  26. }
  27. }
  28. 复制代码

压榨内存

但是这样做的问题就是可能内存会爆掉。如果你的流无限大,那么意味着这些数据都要存在内存中,堆必须要能够建无限大。如果内存必须很小的方式,用时间换空间。

  • 流是可以重复去读的, 用时间换空间;
  • 可以用分治的思想,先读一遍流,把流中的数据个数分桶;
  • 分桶之后遍历桶就可以得到中位数落在哪个桶里面,这样就把问题的范围缩小了。
  1. public class Median {
  2. private static int BUCKET_SIZE = 1000;
  3. private int left = 0;
  4. private int right = Integer.MAX_VALUE;
  5. // 流这里用int[] 代替
  6. public double findMedian(int[] nums) {
  7. // 第一遍读取stream 将问题复杂度转化为内存可接受的量级.
  8. int[] bucket = new int[BUCKET_SIZE];
  9. int step = (right - left) / BUCKET_SIZE;
  10. boolean even = true;
  11. int sumCount = 0;
  12. for (int i = 0; i < nums.length; i++) {
  13. int index = nums[i] / step;
  14. bucket[index] = bucket[index] + 1;
  15. sumCount++;
  16. even = !even;
  17. }
  18. // 如果是偶数,那么就需要计算第topK 个数
  19. // 如果是奇数, 那么需要计算第 topK和topK+1的个数.
  20. int topK = even ? sumCount / 2 : sumCount / 2 + 1;
  21. int index = 0;
  22. int indexBucketCount = 0;
  23. for (index = 0; index < bucket.length; index++) {
  24. indexBucketCount = bucket[index];
  25. if (indexBucketCount >= topK) {
  26. // 当前bucket 就是中位数的bucket.
  27. break;
  28. }
  29. topK -= indexBucketCount;
  30. }
  31. // 划分到这里其实转化为一个topK的问题, 再读一遍流.
  32. if (even && indexBucketCount == topK) {
  33. left = index * step;
  34. right = (index + 2) * step;
  35. return helperEven(nums, topK);
  36. // 偶数的时候, 恰好划分到在左右两个子段中.
  37. // 左右两段中 [topIndex-K + (topIndex-K + 1)] / 2.
  38. } else if (even) {
  39. left = index * step;
  40. right = (index + 1) * step;
  41. return helperEven(nums, topK);
  42. // 左边 [topIndex-K + (topIndex-K + 1)] / 2
  43. } else {
  44. left = index * step;
  45. right = (index + 1) * step;
  46. return helperOdd(nums, topK);
  47. // 奇数, 左边topIndex-K
  48. }
  49. }
  50. }
  51. 复制代码

这里边界条件我们处理好之后,关键还是helperOdd 和 helperEven这两个函数怎么去求topK的问题. 我们还是转化为一个topK的问题,那么求top-K和top(K+1)的问题到这里我们是不是可以用堆来解决了呢? 答案是不能,考虑极端情况。 中位数的重复次数非常多

  1. eg:
  2. [100,100,100,100,100...] (1000亿个100)
  3. 复制代码

你的划分恰好落到这个桶里面,内存同样会爆掉。

再用时间换空间

假如我们的划分bucket大小是10000,那么最大的时候区间就是20000。(对应上面的偶数且落到两个分桶的情况) 那么既然划分到某一个bucket了,我们直接用数数字的方式来求topK 就可以了,用堆的方式也可以,更高效一点,其实这里问题规模已经划分到很小了,两种方法都可以。 我们选用TreeMap这种数据结构计数。然后分奇数偶数去求解。

  1. private double helperEven(int[] nums, int topK) {
  2. TreeMap<Integer, Integer> map = new TreeMap<>();
  3. for (int i = 0; i < nums.length; i++) {
  4. if (nums[i] >= left && nums[i] <= right) {
  5. if (!map.containsKey(nums[i])) {
  6. map.put(nums[i], 1);
  7. } else {
  8. map.put(nums[i], map.get(nums[i]) + 1);
  9. }
  10. }
  11. }
  12. int count = 0;
  13. int kNum = Integer.MIN_VALUE;
  14. int kNextNum = 0;
  15. for (Map.Entry<Integer, Integer> entry : map.entrySet()) {
  16. int currentCountIndex = entry.getValue();
  17. if (kNum != Integer.MIN_VALUE) {
  18. kNextNum = entry.getKey();
  19. break;
  20. }
  21. if (count + currentCountIndex == topK) {
  22. kNum = entry.getKey();
  23. } else if (count + currentCountIndex > topK) {
  24. kNum = entry.getKey();
  25. kNextNum = entry.getKey();
  26. break;
  27. } else {
  28. count += currentCountIndex;
  29. }
  30. }
  31. return (kNum + kNextNum) / 2.0;
  32. }
  33. private double helperOdd(int[] nums, int topK) {
  34. TreeMap<Integer, Integer> map = new TreeMap<>();
  35. for (int i = 0; i < nums.length; i++) {
  36. if (nums[i] >= left && nums[i] <= right) {
  37. if (!map.containsKey(nums[i])) {
  38. map.put(nums[i], 1);
  39. } else {
  40. map.put(nums[i], map.get(nums[i]) + 1);
  41. }
  42. }
  43. }
  44. int count = 0;
  45. int kNum = Integer.MIN_VALUE;
  46. for (Map.Entry<Integer, Integer> entry : map.entrySet()) {
  47. int currentCountIndex = entry.getValue();
  48. if (currentCountIndex + count >= topK) {
  49. kNum = entry.getKey();
  50. break;
  51. } else {
  52. count += currentCountIndex;
  53. }
  54. }
  55. return kNum;
  56. }
  57. 复制代码

至此,我觉得算是一个比较好的解决方案,leetcode社区没有相关的解答和探索,欢迎大家交流。

热门阅读

声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/凡人多烦事01/article/detail/437328
推荐阅读
相关标签
  

闽ICP备14008679号